
;--=======================================================================--
;--==                       Registry Access Module                      ==--
;--==                              v.1.02                               ==--
;--==                      2005 by Mincho Georgiev                     ==--
;--==                       <shaka_zulu@mail.bg>                        ==-
;--=======================================================================--

;--===================================================================--
	SaveString PROTO :DWORD,:DWORD,:DWORD,:DWORD
	GetString  PROTO :DWORD,:DWORD,:DWORD
	SaveDword  PROTO :DWORD,:DWORD,:DWORD,:DWORD
	GetDword   PROTO :DWORD,:DWORD
	SaveBinary PROTO :DWORD,:DWORD,:DWORD,:DWORD
	GetBinary  PROTO :DWORD,:DWORD
	GetBinArray PROTO :DWORD,:DWORD,:DWORD
	GetBinArraySize PROTO :DWORD,:DWORD
;--===================================================================--

.code
;--====================string values==================================--

SaveString PROC	lpszKey:DWORD,lpszValue:DWORD,
				lpszString:DWORD, dwStrLength:DWORD
		
		LOCAL phkResult	:DWORD
		LOCAL lpdwDisposition :DWORD
		
			invoke RegCreateKeyEx,HKEY_LOCAL_MACHINE,
					lpszKey,NULL,NULL,
					REG_OPTION_NON_VOLATILE,KEY_ALL_ACCESS,
					NULL,ADDR phkResult,ADDR lpdwDisposition 
			.if eax==ERROR_SUCCESS			
				invoke RegSetValueEx,phkResult,lpszValue,
						NULL,REG_SZ,lpszString,dwStrLength
				invoke RegCloseKey,phkResult	
				mov eax,TRUE
				ret
			.endif	
xor eax,eax	
ret
SaveString ENDP

GetString PROC  lpszKey:DWORD,lpszValueName:DWORD,lpszBuffer:DWORD
		
		LOCAL dwStrLength:DWORD
		LOCAL phkResult	:DWORD
		LOCAL RType:DWORD
		LOCAL lpcbData :DWORD
		
			mov eax,REG_SZ
			mov RType,eax
			invoke RegCreateKeyEx,HKEY_LOCAL_MACHINE,
					lpszKey,NULL,NULL,
					REG_OPTION_NON_VOLATILE,
					KEY_ALL_ACCESS,
					NULL,ADDR phkResult,ADDR RType
			.if eax==ERROR_SUCCESS
				mov eax,REG_DWORD
				mov RType,eax
				invoke RegQueryValueEx,phkResult,lpszValueName,
						NULL,ADDR RType, lpszBuffer,
						lpcbData 	
				invoke RegCloseKey,phkResult
			.endif
ret
GetString ENDP

;--======================dword values========================================--

SaveDword PROC dwKey:DWORD,dwValue:DWORD,lpDword:DWORD,dwStrLength:DWORD
		
		LOCAL phkResult	:DWORD
		LOCAL lpdwDisposition :DWORD
		
			invoke RegCreateKeyEx,HKEY_LOCAL_MACHINE,
					dwKey,NULL,NULL,
					REG_OPTION_NON_VOLATILE,KEY_ALL_ACCESS,
					NULL,ADDR phkResult,ADDR lpdwDisposition 
					
			.if eax==ERROR_SUCCESS			
					
				invoke RegSetValueEx,phkResult,dwValue,
						NULL,REG_DWORD,lpDword,dwStrLength
				invoke RegCloseKey,phkResult	
				mov eax,TRUE
				ret			
			.endif
		
	xor eax,eax
ret                   
SaveDword ENDP

GetDword PROC	dwKey:DWORD,dwValueName:DWORD
	
		LOCAL dwSize:DWORD
		LOCAL phkResult	:DWORD
		LOCAL lpdwDisposition :DWORD
		LOCAL RType :DWORD
		LOCAL lpData:DWORD
		
			invoke RegCreateKeyEx,HKEY_LOCAL_MACHINE,
						dwKey,NULL,NULL,
						REG_OPTION_NON_VOLATILE,
						KEY_ALL_ACCESS,NULL,
						ADDR phkResult,ADDR lpdwDisposition
					
			.if eax==ERROR_SUCCESS
					
				mov eax,REG_DWORD	
				mov RType,eax
				invoke RegQueryValueEx,phkResult,
						dwValueName,NULL,ADDR RType,
						ADDR lpData,ADDR dwSize
						invoke RegCloseKey,phkResult
						mov eax,lpData
						ret
			.else
					
				mov eax,FALSE
				ret
				
			.endif
ret
GetDword ENDP
;--====================binary values================================================--

SaveBinary PROC dwKey:DWORD,dwValue:DWORD,
				lpDword:DWORD,dwStrLength:DWORD
		
		LOCAL phkResult	:DWORD
		LOCAL lpdwDisposition :DWORD
		
			invoke RegCreateKeyEx,HKEY_LOCAL_MACHINE,
					dwKey,NULL,NULL,
					REG_OPTION_NON_VOLATILE,KEY_ALL_ACCESS,
					NULL,ADDR phkResult,ADDR lpdwDisposition 
			.if eax==ERROR_SUCCESS			
				invoke RegSetValueEx,phkResult,dwValue,
						NULL,REG_BINARY,lpDword,dwStrLength
				invoke RegCloseKey,phkResult	
				mov eax,TRUE
				ret
			.endif
xor eax,eax
ret
SaveBinary ENDP


GetBinary PROC bKey:DWORD,bValueName:DWORD
		
		LOCAL phkResult:DWORD		
		LOCAL Data[128]:BYTE
		LOCAL lpSize:DWORD
		LOCAL RType:DWORD
	
			mov eax,REG_BINARY
			mov RType,eax
			invoke RegOpenKeyEx,HKEY_LOCAL_MACHINE,bKey,NULL,
					KEY_READ,ADDR phkResult
			.if eax==ERROR_SUCCESS
				invoke RegQueryValueEx,phkResult,bValueName,NULL,
						ADDR RType,ADDR Data,ADDR lpSize
				invoke RegCloseKey,phkResult
			.endif
ret
GetBinary ENDP

GetBinArray PROC bKey:DWORD,bValueName:DWORD,lpBuffer:DWORD
		
		LOCAL phkResult:DWORD
		LOCAL lpSize:DWORD
		LOCAL RType:DWORD
		
			mov eax,REG_BINARY
			mov RType,eax
			invoke RegOpenKeyEx,HKEY_LOCAL_MACHINE,bKey,NULL,KEY_READ,ADDR phkResult
			
			.if eax==ERROR_SUCCESS
				invoke RegQueryValueEx,phkResult,bValueName,NULL,ADDR RType,lpBuffer,ADDR lpSize
				invoke RegCloseKey,phkResult
			.endif
ret
GetBinArray ENDP

GetBinArraySize PROC Key:DWORD,lpValueName:DWORD

	LOCAL phkResult:DWORD
	LOCAL RegSize:DWORD
	LOCAL RegType:DWORD
		
		mov RegType,REG_BINARY
		invoke RegOpenKeyEx,HKEY_LOCAL_MACHINE,Key,NULL,KEY_READ,addr phkResult
		.if eax == ERROR_SUCCESS
			invoke RegQueryValueEx,phkResult,lpValueName,NULL,addr RegType,NULL,addr RegSize
			invoke RegCloseKey,phkResult
			mov eax,RegSize
			ret
		.endif
	mov eax,FALSE
ret
GetBinArraySize ENDP
;--================================================================--



